// vbgtH[32̏ꍇf̒l32rbg𒴂 (p >= 2147483647) ƉZxȂ܂B
// 64rbgłB
// test1  9223372036854775806 = 2 ~ 3 ~ 715827883 ~ 2147483647
// test2  1537228672809129301 = 715827883 ~ 2147483647
// test3  6416582420042734637 = 6416582420042734637
// test4  9000000000000001121 = 9000000000000001121
// test5  15372286728550 = 2 ~ 5^2 ~ 31 ~ 337 ~ 29429093

unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, System.Diagnostics;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    LabeledEdit1: TLabeledEdit;
    Button1: TButton;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure prime_factorization(num: int64);
  private
    { Private 錾 }
    AStopWatch : TStopWatch;
    procedure DisplayTime(msTime: Int64);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ^C}[ԕ\
procedure TForm1.DisplayTime(msTime: Int64);
begin
  Panel1.Caption := Format('%5.3f ', [msTime / 1000.0]) + 'sec';
  Panel1.Update;
end;

// f
procedure TForm1.prime_factorization(num: int64);
var
  cnt : int64;                // f̏搔
  i   : int64;                // f
  snum : int64;               // num

  procedure Memoout;          // fl\
  begin
    case cnt of
      0:                      // cnt = 0
        if num > 1 then Memo1.Text := Memo1.Text + inttostr(num);
      1:                      // cnt = 1    i * \
        if num > 1 then Memo1.Text := Memo1.Text + inttostr(i) + ' ~ '
                   else Memo1.Text := Memo1.Text + inttostr(i);
      else                    // cnt > 1    i^cnt * \
        if num > 1 then
          Memo1.Text := Memo1.Text + inttostr(i) + '^' + inttostr(cnt) + ' ~ '
        else
          Memo1.Text := Memo1.Text + inttostr(i) + '^' + inttostr(cnt);
    end;
  end;

begin
  Memo1.Lines.Append('f');
  Memo1.Text := Memo1.Text + ' ' + intTostr(num) + ' = ';
  // f2̌ 2̂
  i := 2;                                 // f2Zbg 
  cnt := 0;                               // 搔=0
  while num mod i = 0 do begin            // ]肪o܂ŏiŏZ
    inc(cnt);                             // ؂ꂽJEg
    num := num div i;                     // Z
  end;
  if cnt > 0 then begin                   // 搔0傫
    Memoout;                              // fl\
    cnt := 0;                             // 搔=0
  end;
  // 3ȏ̊̑f őĺnumȉ
  i := 3;                                 //  l3Zbg
  snum := trunc(sqrt(num)) + 1;           // num
  while i <= snum do begin                // inum菬s
    while num mod i = 0 do begin          // ]肪o܂ŏiŏZ
      inc(cnt);                           // ؂ꂽJEg(搔)
      num := num div i;                   // Z
      snum := trunc(sqrt(num)) + 1;       // num
    end;
    if cnt > 0 then begin                 // 搔0傫
      Memoout;                            // fl\
      cnt := 0;                           // 搔=0
    end;
    inc(i, 2);                            // 2Z
  end;
  Memoout;                                // Ō̒l\
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  num : int64;                            // ͒l
  ch, cc : integer;
  s   : string;
begin
  val(labelededit1.Text, num, ch);        // string->l
  memo1.Clear;
  memo1.update;
  if ch <> 0 then begin                   // ϊG[
    s := labelededit1.Text[ch];           // G[擾
    val(s, num, cc);                      // ~Xl傫mF
    if cc <> 0 then                       // ̃~X̏ꍇ
      Memo1.Text := '͒l' + intTostr(ch) + ' ' + s + ' ԈĂ܂B'
    else                                  // Ƀ~XȂ̏ꍇl傫
      Memo1.Text := '͒l傫܂B';
    exit;
  end;
  if num < 2 then begin
    Memo1.Text := 'Qȏ̒lɂĉB';
    exit;
  end;
  Button1.Enabled := False;
  AStopWatch := TStopwatch.StartNew;            // ^C}[X^[g
  DisplayTime(AStopWatch.ElapsedMilliseconds);  // ԕ\
  prime_factorization(num);                     // f
  AStopWatch.Stop;                              // ^C}[~
  DisplayTime(AStopWatch.ElapsedMilliseconds);  // ԕ\
  Button1.Enabled := True;
end;

end.
